## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 7;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by go2rpm
%bcond_without check

# https://github.com/godoctor/godoctor
%global goipath         github.com/godoctor/godoctor
Version:                0.7

%gometa

%global common_description %{expand:
Go Doctor - The Golang Refactoring Engine.}

%global golicenses      LICENSE
%global godocs          doc README.md

Name:           godoctor
Release:        %autorelease
Summary:        A golang refactoring tool

# Upstream license specification: BSD-3-Clause
License:        BSD-3-Clause
URL:            %{gourl}
Source0:        %{gosource}
# https://github.com/godoctor/godoctor/pull/61
Patch:          0001-Add-missing-error-handlers-to-tests.patch
# https://github.com/godoctor/godoctor/pull/62
Patch:          0002-Normalize-paths-in-TestFindOccurrences.patch
# https://github.com/godoctor/godoctor/pull/63
Patch:          0003-Merge-pull-request-63-from-godoctor-fix-tests-1-20.patch
# Fedora specific
Patch:          0004-Skip-occurrence-test-that-uses-modules.patch
# https://github.com/godoctor/godoctor/issues/60#issuecomment-1450973808
Patch:          0005-Skip-tests-that-appear-to-be-broken.patch
# https://github.com/godoctor/godoctor/pull/64
Patch:          0006-Copy-existing-environment-when-loading-packages.patch
# For under Go 1.20
Patch:          0007-Revert-patch-to-showast-debug-output.patch
# https://github.com/godoctor/godoctor/pull/66
Patch:          0008-Fix-AST-test-on-Go-1.21.patch

BuildRequires:  golang(github.com/willf/bitset)
BuildRequires:  golang(golang.org/x/tools/go/ast/astutil)
BuildRequires:  golang(golang.org/x/tools/go/loader)

%description
%{common_description}

%gopkg

%prep
%goprep
%autopatch -p1 -M 5
%if %{fedora} < 38
%autopatch -p1 6
%endif
%autopatch -p1 7

%build
%gobuild -o %{gobuilddir}/bin/godoctor %{goipath}

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
#export GOCACHE="${PWD}/$(mktemp -d godoctor.XXXXXX)"
%global gotestflags %{gotestflags} -timeout 60m
%gocheck
%endif

%files
%doc README.md
%license LICENSE
%{_bindir}/godoctor

%gopkgfiles

%changelog
* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.7-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sun Feb 11 2024 Maxwell G <maxwell@gtmx.me> - 0.7-6
- Rebuild for golang 1.22.0

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.7-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.7-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Oct 15 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.7-3
- Fix build against Go 1.21

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Mon Apr 03 2023 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.7-1
- Update to latest version (#2088659)

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.6-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.6-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jul 19 2022 Maxwell G <gotmax@e.email> - 0.6-13
- Rebuild for CVE-2022-{1705,32148,30631,30633,28131,30635,30632,30630,1962} in
  golang

* Fri Jun 17 2022 Robert-André Mauchin <zebob.m@gmail.com> - 0.6-12
- Rebuilt for CVE-2022-1996, CVE-2022-24675, CVE-2022-28327, CVE-2022-27191,
  CVE-2022-29526, CVE-2022-30629

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.6-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.6-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.6-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.6-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jan 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.6-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.6-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Thu Jul 11 2019 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.6-5
- Update to latest Go macros

* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.6-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Tue Oct 23 2018 Nicolas Mailhot <nim@fedoraproject.org>
- 0.6-3
- redhat-rpm-config-123 triggers bugs in gosetup, remove it from Go spec files as it’s just an alias
- https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/message/RWD5YATAYAFWKIDZBB7EB6N5DAO4ZKFM/

* Wed Oct 10 2018 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.6-2
- rebuilt

* Tue Aug 14 2018 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 0.6-1
- First package for Fedora

